using System;

namespace Takmicenje
{
    class Program
    {
        static void Main(string[] args)
        {
            int N = int.Parse(Console.ReadLine());
            int[,] portali = new int[N - 1, 2];
            int[] zlatnici = new int[N];
            string[] s;

            for (int i = 0; i < N - 1; i++)
            {
                s = Console.ReadLine().Split(" ");
                for (int j = 0; j < 2; j++)
                    portali[i, j] = int.Parse(s[j]);
            }

            s = Console.ReadLine().Split(" ");
            for (int i = 0; i < N; i++)
                zlatnici[i] = int.Parse(s[i]);

            int Q = int.Parse(Console.ReadLine());
            int[,] upiti = new int[Q, 2];

            for (int i = 0; i < Q; i++)
            {
                s = Console.ReadLine().Split(" ");
                for (int j = 0; j < 2; j++)
                    upiti[i, j] = int.Parse(s[j]);
            }
        }
    }
}